Deflator Class Reference

DEFLATE compressor (RFC 1951) More...

`#include <zdeflate.h>`

Inheritance diagram for Deflator:

## Public Types

enum | { MIN_DEFLATE_LEVEL = 0 , DEFAULT_DEFLATE_LEVEL = 6 , MAX_DEFLATE_LEVEL = 9 }
| Deflate level as enumerated values. More...
enum | { MIN_LOG2_WINDOW_SIZE = 9 , DEFAULT_LOG2_WINDOW_SIZE = 15 , MAX_LOG2_WINDOW_SIZE = 15 }
| Windows size as enumerated values. More...

## Public Member Functions

| Deflator (BufferedTransformation *attachment=NULL, int deflateLevel=DEFAULT_DEFLATE_LEVEL, int log2WindowSize=DEFAULT_LOG2_WINDOW_SIZE, bool detectUncompressible=true)
| Construct a Deflator compressor.
| Deflator (const NameValuePairs &parameters, BufferedTransformation *attachment=NULL)
| Construct a Deflator compressor.
void | SetDeflateLevel (int deflateLevel)
| Sets the deflation level.
int | GetDeflateLevel () const
| Retrieves the deflation level.
int | GetLog2WindowSize () const
| Retrieves the window size.
void | IsolatedInitialize (const NameValuePairs &parameters)
| Initialize or reinitialize this object, without signal propagation.
size_t | Put2 (const byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes for processing.
bool | IsolatedFlush (bool hardFlush, bool blocking)
| Flushes data buffered by this object, without signal propagation.
Public Member Functions inherited from LowFirstBitWriter
| LowFirstBitWriter (BufferedTransformation *attachment)
| Construct a LowFirstBitWriter.
void | PutBits (unsigned long value, unsigned int length)
void | FlushBitBuffer ()
void | ClearBitBuffer ()
void | StartCounting ()
unsigned long | FinishCounting ()
Public Member Functions inherited from Filter
| Filter (BufferedTransformation *attachment=NULL)
| Construct a Filter.
bool | Attachable ()
| Determine if attachable.
BufferedTransformation * | AttachedTransformation ()
| Retrieve attached transformation.
const BufferedTransformation * | AttachedTransformation () const
| Retrieve attached transformation.
void | Detach (BufferedTransformation *newAttachment=NULL)
| Replace an attached transformation.
size_t | TransferTo2 (BufferedTransformation &target, lword &transferBytes, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer bytes from this object to another BufferedTransformation.
size_t | CopyRangeTo2 (BufferedTransformation &target, lword &begin, lword end=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true) const
| Copy bytes from this object to another BufferedTransformation.
void | Initialize (const NameValuePairs &parameters=g_nullNameValuePairs, int propagation=-1)
| Initialize or reinitialize this object, with signal propagation.
bool | Flush (bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output, with signal propagation.
bool | MessageSeriesEnd (int propagation=-1, bool blocking=true)
| Marks the end of a series of messages, with signal propagation.
Public Member Functions inherited from BufferedTransformation
| BufferedTransformation ()
| Construct a BufferedTransformation.
BufferedTransformation & | Ref ()
| Provides a reference to this object.
virtual void | Attach (BufferedTransformation *newAttachment)
| Add newAttachment to the end of attachment chain.
size_t | Put (byte inByte, bool blocking=true)
| Input a byte for processing.
size_t | Put (const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing.
size_t | PutWord16 (word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing.
size_t | PutWord32 (word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing.
size_t | PutWord64 (word64 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 64-bit word for processing.
virtual byte * | CreatePutSpace (size_t &size)
| Request space which can be written into by the caller.
virtual bool | CanModifyInput () const
| Determines whether input can be modified by the callee.
size_t | PutModifiable (byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee.
bool | MessageEnd (int propagation=-1, bool blocking=true)
| Signals the end of messages to the object.
size_t | PutMessageEnd (const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message.
virtual size_t | PutModifiable2 (byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee.
unsigned int | GetMaxWaitObjectCount () const
| Retrieves the maximum number of waitable objects.
void | GetWaitObjects (WaitObjectContainer &container, CallStack const &callStack)
| Retrieves waitable objects.
virtual bool | IsolatedMessageSeriesEnd (bool blocking)
| Marks the end of a series of messages, without signal propagation.
virtual void | SetAutoSignalPropagation (int propagation)
| Set propagation of automatically generated and transferred signals.
virtual int | GetAutoSignalPropagation () const
| Retrieve automatic signal propagation value.
virtual lword | MaxRetrievable () const
| Provides the number of bytes ready for retrieval.
virtual bool | AnyRetrievable () const
| Determines whether bytes are ready for retrieval.
virtual size_t | Get (byte &outByte)
| Retrieve a 8-bit byte.
virtual size_t | Get (byte *outString, size_t getMax)
| Retrieve a block of bytes.
virtual size_t | Peek (byte &outByte) const
| Peek a 8-bit byte.
virtual size_t | Peek (byte *outString, size_t peekMax) const
| Peek a block of bytes.
size_t | GetWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 16-bit word.
size_t | GetWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 32-bit word.
size_t | GetWord64 (word64 &value, ByteOrder order=BIG_ENDIAN_ORDER)
| Retrieve a 64-bit word.
size_t | PeekWord16 (word16 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 16-bit word.
size_t | PeekWord32 (word32 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 32-bit word.
size_t | PeekWord64 (word64 &value, ByteOrder order=BIG_ENDIAN_ORDER) const
| Peek a 64-bit word.
lword | TransferTo (BufferedTransformation &target, lword transferMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL)
| move transferMax bytes of the buffered output to target as input
virtual lword | Skip (lword skipMax=LWORD_MAX)
| Discard skipMax bytes from the output buffer.
lword | CopyTo (BufferedTransformation &target, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object to another BufferedTransformation.
lword | CopyRangeTo (BufferedTransformation &target, lword position, lword copyMax=LWORD_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy bytes from this object using an index to another BufferedTransformation.
virtual lword | TotalBytesRetrievable () const
| Provides the number of bytes ready for retrieval.
virtual unsigned int | NumberOfMessages () const
| Provides the number of meesages processed by this object.
virtual bool | AnyMessages () const
| Determines if any messages are available for retrieval.
virtual bool | GetNextMessage ()
| Start retrieving the next message.
virtual unsigned int | SkipMessages (unsigned int count=UINT_MAX)
| Skip a number of meessages.
unsigned int | TransferMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL)
| Transfer messages from this object to another BufferedTransformation.
unsigned int | CopyMessagesTo (BufferedTransformation &target, unsigned int count=UINT_MAX, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation.
virtual void | SkipAll ()
| Skip all messages in the series.
void | TransferAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL)
| Transfer all bytes from this object to another BufferedTransformation.
void | CopyAllTo (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL) const
| Copy messages from this object to another BufferedTransformation.
virtual bool | GetNextMessageSeries ()
| Retrieve the next message in a series.
virtual unsigned int | NumberOfMessagesInThisSeries () const
| Provides the number of messages in a series.
virtual unsigned int | NumberOfMessageSeries () const
| Provides the number of messages in a series.
size_t | TransferMessagesTo2 (BufferedTransformation &target, unsigned int &messageCount, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer messages from this object to another BufferedTransformation.
size_t | TransferAllTo2 (BufferedTransformation &target, const std::string &channel=DEFAULT_CHANNEL, bool blocking=true)
| Transfer all bytes from this object to another BufferedTransformation.
size_t | ChannelPut (const std::string &channel, byte inByte, bool blocking=true)
| Input a byte for processing on a channel.
size_t | ChannelPut (const std::string &channel, const byte *inString, size_t length, bool blocking=true)
| Input a byte buffer for processing on a channel.
size_t | ChannelPutModifiable (const std::string &channel, byte *inString, size_t length, bool blocking=true)
| Input multiple bytes that may be modified by callee on a channel.
size_t | ChannelPutWord16 (const std::string &channel, word16 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 16-bit word for processing on a channel.
size_t | ChannelPutWord32 (const std::string &channel, word32 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 32-bit word for processing on a channel.
size_t | ChannelPutWord64 (const std::string &channel, word64 value, ByteOrder order=BIG_ENDIAN_ORDER, bool blocking=true)
| Input a 64-bit word for processing on a channel.
bool | ChannelMessageEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Signal the end of a message.
size_t | ChannelPutMessageEnd (const std::string &channel, const byte *inString, size_t length, int propagation=-1, bool blocking=true)
| Input multiple bytes for processing and signal the end of a message.
virtual byte * | ChannelCreatePutSpace (const std::string &channel, size_t &size)
| Request space which can be written into by the caller.
virtual size_t | ChannelPut2 (const std::string &channel, const byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes for processing on a channel.
virtual size_t | ChannelPutModifiable2 (const std::string &channel, byte *inString, size_t length, int messageEnd, bool blocking)
| Input multiple bytes that may be modified by callee on a channel.
virtual bool | ChannelFlush (const std::string &channel, bool hardFlush, int propagation=-1, bool blocking=true)
| Flush buffered input and/or output on a channel.
virtual bool | ChannelMessageSeriesEnd (const std::string &channel, int propagation=-1, bool blocking=true)
| Marks the end of a series of messages on a channel.
virtual void | SetRetrievalChannel (const std::string &channel)
| Sets the default retrieval channel.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm.
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.
Public Member Functions inherited from Waitable
bool | Wait (unsigned long milliseconds, CallStack const &callStack)
| Wait on this object.

## Detailed Description

DEFLATE compressor (RFC 1951)

Since
  Crypto++ 1.0

Definition at line 75 of file zdeflate.h.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Deflate level as enumerated values.

Enumerator
MIN_DEFLATE_LEVEL | Minimum deflation level, fastest speed (0)
DEFAULT_DEFLATE_LEVEL | Default deflation level, compromise between speed (6)
MAX_DEFLATE_LEVEL | Minimum deflation level, slowest speed (9)

Definition at line 79 of file zdeflate.h.

## anonymous enum

anonymous enum

Windows size as enumerated values.

Enumerator
MIN_LOG2_WINDOW_SIZE | Minimum window size, smallest table (9)
DEFAULT_LOG2_WINDOW_SIZE | Default window size (15)
MAX_LOG2_WINDOW_SIZE | Maximum window size, largest table (15)

Definition at line 88 of file zdeflate.h.

## Constructor & Destructor Documentation

## Deflator() [1/2]

Deflator::Deflator | ( | BufferedTransformation * | attachment = `NULL`,
|  | int | deflateLevel = `DEFAULT_DEFLATE_LEVEL`,
|  | int | log2WindowSize = `DEFAULT_LOG2_WINDOW_SIZE`,
|  | bool | detectUncompressible = `true`
| ) |  |

Construct a Deflator compressor.

Parameters

  attachment | an attached transformation
  deflateLevel | the deflate level
  log2WindowSize | the window size
  detectUncompressible | flag to detect if data is compressible

detectUncompressible makes it faster to process uncompressible files, but if a file has both compressible and uncompressible parts, it may fail to compress some of the compressible parts.

Definition at line 237 of file zdeflate.cpp.

## Deflator() [2/2]

Deflator::Deflator | ( | const NameValuePairs & | parameters,
|  | BufferedTransformation * | attachment = `NULL`
| ) |  |

Construct a Deflator compressor.

Parameters

  parameters | a set of NameValuePairs to initialize this object
  attachment | an attached transformation

Possible parameter names: Log2WindowSize, DeflateLevel, DetectUncompressible

Definition at line 245 of file zdeflate.cpp.

## Member Function Documentation

## SetDeflateLevel()

void Deflator::SetDeflateLevel | ( | int | deflateLevel | ) |

Sets the deflation level.

Parameters

  deflateLevel | the level of deflation

SetDeflateLevel can be used to set the deflate level in the middle of compression

Definition at line 316 of file zdeflate.cpp.

## GetDeflateLevel()

int Deflator::GetDeflateLevel | ( |  | ) | const

inline

Retrieves the deflation level.

Returns
  the level of deflation

Definition at line 118 of file zdeflate.h.

## GetLog2WindowSize()

int Deflator::GetLog2WindowSize | ( |  | ) | const

inline

Retrieves the window size.

Returns
  the windows size

Definition at line 122 of file zdeflate.h.

## IsolatedInitialize()

void Deflator::IsolatedInitialize | ( | const NameValuePairs & | parameters | ) |

virtual

Initialize or reinitialize this object, without signal propagation.

Parameters

  parameters | a set of NameValuePairs to initialize this object

Exceptions

  NotImplemented |

IsolatedInitialize() is used to initialize or reinitialize an object using a variable number of arbitrarily typed arguments. The function avoids the need for multiple constructors providing all possible combintations of configurable parameters.

IsolatedInitialize() does not call Initialize() on attached transformations. If initialization should be propagated, then use the Initialize() function.

If a derived class does not override IsolatedInitialize(), then the base class throws NotImplemented.

Reimplemented from BufferedTransformation.

Reimplemented in Gzip.

Definition at line 265 of file zdeflate.cpp.

## Put2()

size_t Deflator::Put2 | ( | const byte * | inString,
|  | size_t | length,
|  | int | messageEnd,
|  | bool | blocking
| ) |  |

virtual

Input multiple bytes for processing.

Parameters

  inString | the byte buffer to process
  length | the size of the string, in bytes
  messageEnd | means how many filters to signal MessageEnd() to, including this one
  blocking | specifies whether the object should block when processing input

Returns
  the number of bytes that remain to be processed (i.e., bytes not processed). 0 indicates all bytes were processed.

Derived classes must implement Put2().

Implements BufferedTransformation.

Definition at line 521 of file zdeflate.cpp.

## IsolatedFlush()

bool Deflator::IsolatedFlush | ( | bool | hardFlush,
|  | bool | blocking
| ) |  |

virtual

Flushes data buffered by this object, without signal propagation.

Parameters

  hardFlush | indicates whether all data should be flushed
  blocking | specifies whether the object should block when processing input

Returns
  true if the flush was successful, false otherwise

Note
  hardFlush must be used with care

Implements BufferedTransformation.

Definition at line 551 of file zdeflate.cpp.

The documentation for this class was generated from the following files:

- zdeflate.h
- zdeflate.cpp